/*
* MiniGUI Grid Demo
* (c) 2005 Roberto Lopez
*/

#include "minigui.ch"
#include "i_xgrid.ch"
#include 'adodb.ch'


set procedure to h_xgrid.prg

Function Main
	Local oConn, oRs

	SET DATE BRITISH
	SET CENTURY ON
		
	oConn := TOleauto():new('ADODB.Connection')
	oConn:ConnectionString:= "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=bd1.mdb;User Id=admin;"
	oConn:Open()
	
	oRs = TOleauto():New('ADODB.Recordset')
	oRs:CursorLocation= adUseClient
	oRs:Open( "Select FIRST,LAST,HIREDATE,MARRIED from CUSTOMER", oConn, adOpenDynamic, adLockOptimistic )
	
	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 640 ;
		HEIGHT 400 ;
		TITLE 'Mixed Data Type Grid Test' ;
		MAIN ;
		ON PAINT ( ajustar() )


		DEFINE MAIN MENU
			DEFINE POPUP 'File'
				MENUITEM "Exit" ACTION ( oRs:close, oConn:close(), Form_1.release )
			END POPUP
			DEFINE POPUP "Edit"
				MENUITEM 'Get Item'	ACTION GetItem(oRs)
				SEPARATOR
				MENUITEM 'Delete Item'	ACTION Del(oRs)
			END POPUP
		END MENU
		
		DEFINE LABEL LABEL_1
			ROW 	0
			COL 	5
			WIDTH 	80
			HEIGHT 	20
			VALUE 	"Filter:"
		END LABEL

		DEFINE COMBOBOX COMBO_1
			ROW 	0
			COL 	90
			WIDTH 	100
			HEIGHT 	100
			ITEMS 	{"Remove filter", 'First','Last'}		
			VALUE 	1
		END COMBOBOX
		
		DEFINE TEXTBOX TEXT_1
			ROW 	0
			COL 	200
			WIDTH 	100
			HEIGHT 	20
			VALUE 	""
		END TEXTBOX
		
		DEFINE BUTTON BTN_3
			ROW 	0
			COL 	310
			WIDTH 	80
			HEIGHT 	20
			CAPTION "Filtro"
			ACTION 	Filtro(oRs)
		END BUTTON
				
		@ 25,10 GRIDADO Grid_1 ;
			WIDTH 	620 ;
			HEIGHT 	330 ;
			HEADERS {'First','Last','Date','Married'} ;
			WIDTHS 	{100,100, 240, 100} ;
			ITEMS 	oRs ;
			EDIT 		;
			COLUMNCONTROLS {{'TEXTBOX','CHARACTER'}, ;
							{'TEXTBOX','CHARACTER'}, ;
							{'TEXTBOX','DATE'}, ;
							{'CHECKBOX','Married','Single'}  } ;
			COLUMNWHEN	{ { || .T. }, { || .T. }, { || .T. }, { || .T. } };
			COLUMNVALID { { || .T. }, { || .T.}, { || .T. }, { || .T. } }

	END WINDOW

	CENTER WINDOW Form_1
	
	ON KEY DELETE OF form_1 ACTION DEL( oRs )
	ACTIVATE WINDOW Form_1

Return

PROCEDURE GETITEM(ORS)
	LOCAL A
	IF FORM_1.GRID_1.VALUE > 0
		A = "FIRST  = "+FORM_1.GRID_1.CELL( FORM_1.GRID_1.VALUE, 1)+HB_OSNEWLINE()+;
			"LAST   = "+FORM_1.GRID_1.CELL( FORM_1.GRID_1.VALUE, 2)+HB_OSNEWLINE()+;
			"DATE   = "+DTOC(FORM_1.GRID_1.CELL( FORM_1.GRID_1.VALUE, 3))+HB_OSNEWLINE()+;
			"MARRIED= "+IF( FORM_1.GRID_1.CELL( FORM_1.GRID_1.VALUE, 4),'MARRIED','SINGLE')
    	
		MSGINFO( A )	
	ELSE
		MSGINFO('Select a some record')
	ENDIF
RETURN

PROCEDURE AJUSTAR
	FORM_1.GRID_1.WIDTH := ( FORM_1.WIDTH - FORM_1.GRID_1.COL ) - (FORM_1.GRID_1.COL+10)
	FORM_1.GRID_1.HEIGHT:= ( FORM_1.HEIGHT- FORM_1.GRID_1.ROW ) - 70
RETURN

PROCEDURE FILTRO( oRs )
	FORM_1.GRID_1.DELETEALLITEMS
	IF FORM_1.COMBO_1.VALUE = 1
		ORS:FILTER:=""
	ELSE
		IF LEN( FORM_1.TEXT_1.VALUE ) > 0
			ORS:FILTER:=FORM_1.COMBO_1.ITEM(FORM_1.COMBO_1.VALUE)+" LIKE '"+FORM_1.TEXT_1.VALUE+"%'"		
		ELSE
			MSGSTOP('INPUT CONDITION FOR CREATE FILTER')
			RETURN
		ENDIF
	ENDIF
	
	FORM_1.GRID_1.UPDATE
	
RETURN

PROCEDURE DEL()
	IF MSGYESNO('DELETE ITEM')
		FORM_1.GRID_1.DELETE( FORM_1.GRID_1.VALUE )
	ENDIF
RETURN